"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const core_1 = require('@angular/core');
const models_1 = require('../models');
let ImageUploadComponent = class ImageUploadComponent {
    constructor() {
        this.onChange = new core_1.EventEmitter();
        this.config = new models_1.ImageUploadConfiguration();
        this.images = [];
        this.fileReader = new FileReader();
        this.fileReader.addEventListener('load', () => {
            let data = this.fileReader.result;
            let img = new models_1.ImageUpload(data, this.currentFile.name, this.currentFile.size);
            this.images.push(img);
        });
    }
    ngOnInit() {
        this._processOptions();
    }
    upload(files) {
        if (files != null) {
            this.currentFile = files[0];
            this.fileReader.readAsDataURL(this.currentFile);
            files = null;
        }
    }
    removeImage(index) {
        this.images.splice(index, 1);
    }
    _processOptions() {
        if (this.opts != null) {
            if (this.opts.addSectionHeader != null) {
                this.config.addSectionHeader = this.opts.addSectionHeader;
            }
            if (this.opts.uploadedHeader != null) {
                this.config.uploadedHeader = this.opts.uploadedHeader;
            }
            if (this.opts.buttonLabel != null) {
                this.config.buttonLabel = this.opts.buttonLabel;
            }
        }
    }
};
__decorate([
    core_1.Input('upload-config'), 
    __metadata('design:type', Object)
], ImageUploadComponent.prototype, "opts", void 0);
__decorate([
    core_1.Output(), 
    __metadata('design:type', core_1.EventEmitter)
], ImageUploadComponent.prototype, "onChange", void 0);
ImageUploadComponent = __decorate([
    core_1.Component({
        selector: `image-upload`,
        template: `
        <div class="row images-detail">
            <div class="col-xs-12">

            <h4 *ngIf="images.length > 0">{{config.uploadedHeader}}</h4>

            <div class="upload-container">
                <div class="upload-item" *ngFor="let image of images; let i = index;" (click)="removeImage(i)">
                <img  [src]="image.data" style="max-height: 100px; max-width: 100px;" />
                <p class="upload-title">{{image.fileName}}</p>
                <p class="upload-file-size">{{image.size | fileSize:1}}</p>
                </div>
            </div>

            <h4>{{config.addSectionHeader}}</h4>
            <input type="file" #fileUpload style="display: none;" accept="image/*" (change)="upload(fileUpload.files)"/>
            <button class="btn btn-bordered" (click)="fileUpload.click()"><i class="fa fa-plus"></i> {{config.buttonLabel}}</button>
            <p><small>Accepted formats: JPG, PNG and GIF</small></p>
            </div>
        </div>
    `,
        styles: [
            `.upload-container {
            display: flex; }`,
            `.upload-item {
            display: inline-block;
            max-width: 120px;
            text-align: center; }`,
            `.upload-item + .upload-item {
            margin-left: 2rem; }`,
            `.upload-title {
            margin-top: 1rem;
            word-wrap: break-word; }`,
            `.upload-file-size {
            font-weight: bold; }`
        ]
    }), 
    __metadata('design:paramtypes', [])
], ImageUploadComponent);
exports.ImageUploadComponent = ImageUploadComponent;
//# sourceMappingURL=image-upload.component.js.map